/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package org.netbeans.modules.php.drupal.ui.options;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.netbeans.modules.php.drupal.DrupalDevelPreferences;
import org.netbeans.modules.php.drupal.util.Util;
import org.netbeans.modules.php.drupal.util.LibraryParser;

final class DrupalPanel extends javax.swing.JPanel {

    private final DrupalOptionsPanelController controller;

    DrupalPanel(DrupalOptionsPanelController controller) {
        this.controller = controller;
        initComponents();
        drupalLibraryPathTextField.getDocument().addDocumentListener(new DocumentListener() {

            @Override
            public void insertUpdate(DocumentEvent e) {
                validateLibraryPath();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                validateLibraryPath();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                validateLibraryPath();
            }
        });
        validateLibraryPath();
        
        txtDrushPath.getDocument().addDocumentListener(new DocumentListener() {

            @Override
            public void insertUpdate(DocumentEvent e) {
                validateDrushPath();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                validateDrushPath();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                validateDrushPath();
            }
        });
        validateDrushPath();        

        // TODO listen to changes in form fields and call controller.changed()
    }
    
    private void validateLibraryPath(){
        updateDrupalVersions();
    }
    
    private Boolean validateDrushPath(){
        Boolean pathGood = DrupalDevelPreferences.validateDrushPath(txtDrushPath.getText().toString());
        if (pathGood){
            lblInvalidDrush.setVisible(false);
        } else {
            lblInvalidDrush.setVisible(true);
        }
        return pathGood;
    }    
    
    private void updateDrupalVersions(){
        this.cbDrupalVersion.removeAllItems();
        String drVer = DrupalDevelPreferences.getDefaultDrupalVersion();

        String path = DrupalDevelPreferences.libraryInstallPath() + "/code";

        ArrayList items = LibraryParser.parseTree(path);
        for (int i = 0; i < items.size(); i++) {
            String item = items.get(i).toString();
            Object obj = Util.makeObj(item);
            cbDrupalVersion.addItem(obj);
            if (item.toString().equals(drVer)) {
                cbDrupalVersion.setSelectedItem(obj);
            }            
        }         
        
    }
      
    private String getDrushPath(){
        return txtDrushPath.getText();
    }
  
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        drupalLibraryPathTextField = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        lblInvalidDrush = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();
        txtDrushPath = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        cbDrupalVersion = new javax.swing.JComboBox();

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.jLabel1.text")); // NOI18N

        drupalLibraryPathTextField.setText(org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.drupalLibraryPathTextField.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jButton1, org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.jButton1.text")); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(drupalLibraryPathTextField)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(drupalLibraryPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1))
                .addContainerGap())
        );

        lblInvalidDrush.setFont(new java.awt.Font("Tahoma", 3, 11));
        lblInvalidDrush.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/netbeans/modules/php/drupal/wizards/dialog-warning.png"))); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(lblInvalidDrush, org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.lblInvalidDrush.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jButton3, org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.jButton3.text")); // NOI18N
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        txtDrushPath.setText(org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.txtDrushPath.text")); // NOI18N
        txtDrushPath.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtDrushPathActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(jLabel3, org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.jLabel3.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, org.openide.util.NbBundle.getMessage(DrupalPanel.class, "DrupalPanel.jLabel2.text")); // NOI18N

        cbDrupalVersion.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(txtDrushPath)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton3)
                        .addGap(4, 4, 4))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(lblInvalidDrush)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(cbDrupalVersion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(0, 293, Short.MAX_VALUE))))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(cbDrupalVersion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtDrushPath, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblInvalidDrush)
                .addContainerGap(86, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Util.browseDrupalLibraryPath(this, drupalLibraryPathTextField);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void txtDrushPathActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtDrushPathActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtDrushPathActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        Util.browseDrupalLibraryPath(this, txtDrushPath);
    }//GEN-LAST:event_jButton3ActionPerformed

    void load() {
        drupalLibraryPathTextField.setText(DrupalDevelPreferences.getDefaultLibraryPath());
        txtDrushPath.setText(DrupalDevelPreferences.getDrushPath());
    }

    void store() {
        DrupalDevelPreferences.setDefaultDrupalVersion(cbDrupalVersion.getSelectedItem().toString());
        DrupalDevelPreferences.setDefaultLibraryPath(drupalLibraryPathTextField.getText());
        DrupalDevelPreferences.setDrushPath(getDrushPath());
        
    }

    boolean valid() {
        // TODO check whether form is consistent and complete
        updateDrupalVersions();
        return true;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox cbDrupalVersion;
    private javax.swing.JTextField drupalLibraryPathTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel lblInvalidDrush;
    private javax.swing.JTextField txtDrushPath;
    // End of variables declaration//GEN-END:variables
}
