/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.modules.php.drupal.wizards.theme;

import java.util.ArrayList;
import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.netbeans.modules.php.drupal.DrupalDevelTool;
import org.netbeans.modules.php.drupal.wizards.WizardUtils;
import org.openide.util.NbPreferences;

public final class ThemeWizardVisualPanel2  extends JPanel implements DocumentListener {

    private String folderPath;
    private String moduleSafeName;
    private final ThemeWizardWizardPanel2 panel;
    private ArrayList fileList = new ArrayList();

    public String drupalVer = "";
    public String libraryPath = "";
    private boolean cbInit = false;
    /** Creates new form ModuleVisualPanel2 */
    public ThemeWizardVisualPanel2(ThemeWizardWizardPanel2 panel) {
        initComponents();
        this.panel = panel;
        jTextField1.getDocument().addDocumentListener(this);
        this.lblExists.setVisible(false);
    }

    @Override
    public String getName() {
        return "Module Information";
    }

    public void showWarning(String name) {
        this.lblExists.setText("The folder " + name + " exists!");
        this.lblExists.setVisible(true);
    }

    public void hideWarning() {
        this.lblExists.setVisible(false);
    }

    public void insertUpdate(DocumentEvent e) {
        moduleSafeName = jTextField1.getText().replaceAll("[^a-zA-Z0-9_]", "_").toLowerCase();
        panel.fireChangeEvent(jTextField1.getText(), moduleSafeName);
        updateGeneratedFilesList(jTextField1.getText());
    }

    public void removeUpdate(DocumentEvent e) {
        moduleSafeName = jTextField1.getText().replaceAll("[^a-zA-Z0-9_]", "_").toLowerCase();
        panel.fireChangeEvent(jTextField1.getText(), moduleSafeName);
        updateGeneratedFilesList(jTextField1.getText());
    }

    public void changedUpdate(DocumentEvent e) {
        moduleSafeName = jTextField1.getText().replaceAll("[^a-zA-Z0-9_]", "_").toLowerCase();
        panel.fireChangeEvent(jTextField1.getText(), moduleSafeName);
        updateGeneratedFilesList(jTextField1.getText());
    }

    private void updateGeneratedFilesList(String moduleName) {
        if (this.cbInit == false) {
            cbDrupalVersion.addActionListener(new java.awt.event.ActionListener() {

                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    fileList.clear();
                    updateGeneratedFilesList(jTextField1.getText());
                }
            });
            cbInit = true;
        }        
        if (this.fileList.size()==0) {
            
            this.fileList = WizardUtils.getFilesList(this.libraryPath + "/" + this.cbDrupalVersion.getSelectedItem().toString());

        }
        String generatedFiles = "";
        moduleSafeName = moduleName.replaceAll("[^a-zA-Z0-9_]", "_").toLowerCase();
        for (int i = 0; i < this.fileList.size(); i++) {
            String item = this.fileList.get(i).toString();
            
            String name = WizardUtils.fileName(item, moduleSafeName);
            generatedFiles += folderPath + moduleSafeName + "/" + name + "\n";
        }
        jTextArea1.setText(generatedFiles);
        jTextField2.setText(folderPath + moduleSafeName);
    }

    public ArrayList getFileList() {
        return this.fileList;
    }

    public String getModuleName() {
        return jTextField1.getText();
    }

    public String getModuleSafeName() {
        return jTextField1.getText().replaceAll("[^a-zA-Z0-9_]", "_").toLowerCase();
    }

    public void setFolderPath(final String folderPath) {
        jTextField2.setText(folderPath);
        this.folderPath = folderPath + "/";
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTextField2 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        lblExists = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        cbDrupalVersion = new javax.swing.JComboBox();

        setPreferredSize(new java.awt.Dimension(478, 238));

        jTextField2.setEditable(false);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(ThemeWizardVisualPanel2.class, "ThemeWizardVisualPanel2.jLabel1.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, org.openide.util.NbBundle.getMessage(ThemeWizardVisualPanel2.class, "ThemeWizardVisualPanel2.jLabel2.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel3, org.openide.util.NbBundle.getMessage(ThemeWizardVisualPanel2.class, "ThemeWizardVisualPanel2.jLabel3.text")); // NOI18N

        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        lblExists.setFont(new java.awt.Font("Tahoma", 3, 11));
        lblExists.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/netbeans/modules/php/drupal/wizards/dialog-warning.png"))); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(lblExists, org.openide.util.NbBundle.getMessage(ThemeWizardVisualPanel2.class, "ThemeWizardVisualPanel2.lblExists.text")); // NOI18N

        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextField1KeyTyped(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(jLabel4, org.openide.util.NbBundle.getMessage(ThemeWizardVisualPanel2.class, "ThemeWizardVisualPanel2.jLabel4.text")); // NOI18N

        cbDrupalVersion.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cbDrupalVersion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbDrupalVersionActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(42, 42, 42)
                .addComponent(lblExists)
                .addContainerGap(375, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addGap(123, 123, 123)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(cbDrupalVersion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField2, javax.swing.GroupLayout.DEFAULT_SIZE, 268, Short.MAX_VALUE)
                            .addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 268, Short.MAX_VALUE)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 270, Short.MAX_VALUE))
                        .addGap(36, 36, 36))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(cbDrupalVersion))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(38, 38, 38)
                .addComponent(lblExists)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed

    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jTextField1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyTyped
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField1KeyTyped

    private void cbDrupalVersionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbDrupalVersionActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_cbDrupalVersionActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JComboBox cbDrupalVersion;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JLabel lblExists;
    // End of variables declaration//GEN-END:variables
}
